local _, slicore = ...;
local SLICERTNG_MainFrame = nil;
local SLICERTNG_SnDStatusBar = nil;
local SLICERTNG_Status = 1;
local SLICERTNG_SunderArmorStatusBar = nil;


local function HandleSlashCommands(params)
    if (#params == 0) then
        slicore.Init.commands.help();
        return;
    end

    local args = {};

    for _, arg in ipairs({string.split(' ', params) }) do
        if (#arg > 0) then
            table.insert(args, arg);
        end
    end

    local sprungpfad = slicore.Init.commands;

    for id,arg in ipairs(args) do
        arg = string.lower(arg);

        if (sprungpfad[arg]) then
            if (type(sprungpfad[arg]) == "function") then
                sprungpfad[arg] (select (id+1,unpack(args)));
                return;
            elseif (type(sprungpfad[arg]) == "table") then
                sprungpfad = sprungpfad[arg];
            else
                slicore.Init.commands.help();
                return;
            end
        else
            slicore.Init.commands.help();
            return;
        end
    end
end

function slicore:startup(event, name)
    --if (name ~= "SlicerTNG") then return end
    if (event == "SPELLS_CHANGED") then
        slicore.Init:Print("SLI TNG is Alive");
        self:UnregisterEvent("SPELLS_CHANGED");
        local klasse, class = UnitClass("player");
        if(class == "ROGUE") then
            slicore.Mainwindow:startup(2);
            --slicore.Optionswindow:startup(2);
        end
    end
    
    if (event == "VARIABLES_LOADED") then
        if(SLICERTNG_OPTIONS["ShowLife"] == nil) then
             SLICERTNG_OPTIONS["ShowLife"] = true;
        end
        if(SLICERTNG_OPTIONS["ShowEnergy"] == nil) then
            SLICERTNG_OPTIONS["ShowEnergy"] = true;
       end
       if(SLICERTNG_OPTIONS["UnlockBuffs"] == nil) then
            SLICERTNG_OPTIONS["UnlockBuffs"] = false;
       end
       if(SLICERTNG_OPTIONS["BuffPositions"] == nil) then
            SLICERTNG_OPTIONS["BuffPositions"] = {93,15,93,-15};
       end
       if(SLICERTNG_OPTIONS["LockPosition"] == nil) then
            SLICERTNG_OPTIONS["LockPosition"] = false;
       end
       if(SLICERTNG_OPTIONS["ShowSunder"] == nil) then
        SLICERTNG_OPTIONS["ShowSunder"] = false;
       end
       slicore.VariablesLoaded = true;
       --slicore.Optionswindow:getoptions();
    end

    if (name == "SlicerTNG") then 
        slicore.Init:Print("SLI TNG Loaded");
        self:UnregisterEvent("ADDON_LOADED");
        for i = 1, NUM_CHAT_WINDOWS do
            _G["ChatFrame"..i.."EditBox"]:SetAltArrowKeyMode(false);
        end

        SLASH_RELOADUI1 = "/rl";
        SlashCmdList.RELOADUI = ReloadUI;
        SLASH_SlicerTNG1 = "/slit";
        SLASH_SlicerTNG2 = "/sli";
        SlashCmdList.SlicerTNG = HandleSlashCommands;
        SLASH_FRAMESTK1 = "/fs"; -- new slash command for showing framestack tool
        SlashCmdList.FRAMESTK = function()
            LoadAddOn("Blizzard_DebugTools");
            FrameStackTooltip_Toggle();
        end


        slicore.Init:Print(SLICER_WELCOME.. UnitName("player"));
        local klasse, class = UnitClass("player");
        if(class == "ROGUE") then
            slicore.Init:Print(SLICER_YOUARE);
            slicore.Mainwindow:startup(1);
            slicore.Optionswindow:startup(1);
        else
            slicore.Init:Print(SLICER_SIGNOFF);
            SLICERTNG_Status = 0;
        end
    end
end

kickoff = CreateFrame("Frame");
kickoff:RegisterEvent("SPELLS_CHANGED");
kickoff:RegisterEvent("ADDON_LOADED");
kickoff:RegisterEvent("VARIABLES_LOADED");
kickoff:SetScript("OnEvent",slicore.startup);
